/* 在此文件写入自定义配置
 * 属性名称不能修改，写入的内容均可在lib.$$config中取到
 * 系统配置参数说明可以在参考文档GLOBAL中找到，参考默认配置进行修改，与默认值相同时无需重复配置
 * 注意，运行时修改此文件无效，需要重新运行工程
 */
PROJECT_CONFIG = {
  // 微应用版本
  version: 0.1,
  // 微应用名称
  siteName: "电商入库零星物资RFID标签管理系统",
  // 微应用简称
  minSiteMame: "RFID",
  // 系统运行时是否显示错误信息
  showErrorTips: true,
  // 系统API请求超时时间
  requestTimeout: 0,
  // 上下文
  projectContext: "/scm-app",
  // 主页面路径
  portalPath: "/admin",
  // 首页路径
  portalHome: "/admin/index",
  // 页面颜色主题
  defaultTheme: ["#eb6652", "#1f5011"],
  // 后端服务类型
  backServerType: "msa",
  backServerRoot: "http://10.131.216.16:31999",
  // 指定当前工程所属命名空间、系统及后端系统根路径
  system: {
    namespace: "scm",
    name: "scm",
    root: "/scm"
  },
  // 认证服务网关
  authServiceConfig: {
    gatewayRoute: "/scm/scm.direwolf-auth"
  },

  // 微服务服务监控后端地址，仅在开发中使用
  // graphqlServer: 'http://192.168.150.24:12800',
  // SBA后端地址，仅在开发中使用
  // sbaServer: 'http://192.168.150.24:30006',
  // homeMenuWidth: 300,
  // backServerType: 'soa',
  // backServerRoot: 'http://localhost:8480/direwolf_app_war_exploded',
  // authServiceConfig: {
  //   gatewayRoute: '/auth',
  // },
  // activitiServiceConfig: {
  //   adminPath: '/a',
  //   gatewayRoute: '/activiti',
  // },
  sysServiceConfig: {
    adminPath: "/a",
    context: "/sys-app",
    gatewayRoute: "/scm/scm.direwolf-sys"
  }
  // dashboardServiceConfig: {
  //   adminPath: '/a',
  //   gatewayRoute: '/sys',
  // },
};

if (typeof module !== "undefined") {
  // 开发环境WEBPACK环境使用
  module.exports = PROJECT_CONFIG;
}
