import Home from "../views/Home.vue";
import config from "../config";

const lib = window.getDirewolfLibrary();
const routeList = [
  {
    path: "/page-in-src/",
    name: "home",
    meta: {
      title: "根路由",
      permission: "isAuthenticated"
    },
    component: Home
  },
  {
    path: "/page-in-src/about",
    name: "about",
    meta: {
      title: "其他路由",
      permission: "isAuthenticated"
    },
    component: () =>
      import(/* webpackChunkName: "about" */ "../views/About.vue")
  }
];

const router = lib.$$utils.router.createRouter(routeList);

// router.beforeEach((to, from,next) => {
//   lib.$$utils.beforeEachRoute({ to, from, next }, { router, module, })
// })

router.afterEach(transition => {
  const { siteName } = config;
  const { title } = transition.meta;
  window.document.title = title ? `${title} - ${siteName}` : siteName;
});

export default router;
